#!/usr/bin/perl

use Getopt::Long;
GetOptions("help!"=>\$help,"path=s"=>\$vibh_home,"input=s"=>\$input,"output=s",\$output);
print "Unprocessed by Getopt::Long\n" if $ARGV[0];
foreach (@ARGV) {
	print "$_\n";
	exit(0);
}

if($help eq 1) {
	print "Telugu Generator  - Generator Version 0.91\n(9th Sep 2008 )\n\n";
	print "usage : perl ./mul_word.pl --path=/home/mul_word [-i inputfile|--input=\"input_file\"] [-o outputfile|--output=\"output_file\"] \n";
	print "\tIf the output file is not mentioned then the output will be printed to STDOUT\n";
	exit(0);
}

if($vibh_home eq "") {
	print "Please Specify the Path as defined in --help\n";
	exit(0);

}

require "$vibh_home/API/shakti_tree_api.pl";
require "$vibh_home/API/feature_filter.pl";

open(ROOTDICT,"$vibh_home/data_src/Rule");
@ROOTS = <ROOTDICT>;
chomp(@ROOTS);

%root_hash = ();
foreach $root_1 (@ROOTS) {
	($root,$pdgm) = split(/\,/,$root_1);
	$key = $root;
	$root_hash{$key} = $pdgm;
}

sub mul_word {
	&read($input);
	@nodes=&get_leaves();
	@tree=&get_children();
	for($n=0;$n<=@tree;$n++) {
		$cword2 = &get_field($tree[$n],4);
		$fst = &read_FS($cword2);
		@hvib = &get_values("vib", $fst);
		@hhead = &get_values("lex", $fst);
		for($i=0;$i<=@nodes;$i++) {
			$cword = &get_field($nodes[$i],4);
			$fs_array = &read_FS($cword);
			@lex = &get_values("lex", $fs_array);
			@cat = &get_values("cat", $fs_array);
			@name = &get_values("name", $fs_array);
			foreach $lex(@lex) {
				$lex=~s/_.*$//g;
				$cword = $lex;
			}

			if($i!=0) {
				$pword1 = &get_field($nodes[$i-1],4);
				$fs_array1 = &read_FS($pword1);
				@lex1 = &get_values("lex", $fs_array1);
				@cat1 = &get_values("cat", $fs_array1);
				@name1 = &get_values("name", $fs_array1);
				my @vib = &get_values("vib", $fs_array1);

				foreach $lex1(@lex1) {
					$lex1=~s/_.*$//g;
					$pword1 = $lex1;
				}
				$pword2="";
#$key1=$pword1." ".$cword;


			}
			if($i!=0 and $i!=1) {
				$pword1 = &get_field($nodes[$i-1],4);
				$fs_array1 = &read_FS($pword1);
				@lex1 = &get_values("lex", $fs_array1);
				@cat1 = &get_values("cat", $fs_array1);
				@name1 = &get_values("name", $fs_array1);
				my	@vib1 = &get_values("vib", $fs_array1);
				foreach $lex1(@lex1) {
					$pword1 = $lex1;
					$vib1 = $vib1[0];
				}
				$pword2 = &get_field($nodes[$i-2],4);
				$fs_array2 = &read_FS($pword2);
				@lex2 = &get_values("lex", $fs_array2);
				@cat2 = &get_values("cat", $fs_array2);
				@name2 = &get_values("name", $fs_array2);
				$lex23=$lex2[0];

				if(($cat2[0] eq "adj")&&($cat1[0] eq "adj")&&($cat[0] eq "n")&&($pword1=~/^$lex23$/)){
					my @num;
					$num[0]="pl";
					$fs=&get_field($nodes[$i],4);
					$fs_array = &read_FS($fs,$sent);
					&update_attr_val("num",\@num, $fs_array,$sent);
					my $string=&make_string($fs_array,$sent);
					&modify_field($nodes[$i],4,$string);
					$i++;
				}

				foreach $lex2(@lex2) {
					$pword2 = $lex2;
				}
				if($pword1=~/minus;$/){
				$pword1="-";
				}
				$key1=$pword2." ".$pword1." ".$cword;
				if($root_hash{$key1} ne "") {
					my @arr1=split(" ",$root_hash{$key1});
					$j=$i-2;
					foreach (@arr1) {
						$lex[0]=$_;

						if($lex[0]!~/^-/){
							$lex[0]="^@".$lex[0];
						}

						if($lex[0]=~/:/){
							($templex,$cas)=split(/:/,$lex[0]);
							$cas=~s/-/-^@/g;
							$cas=~s/_/_^@/g;
							$newvib1[0]="^-@".$cas;
							$lex[0]=$templex;
							&modify_field($nodes[$j],2,$lex[0]);
							&update_attr_val("vib",\@newvib1, $fs_array,$sent);
							my $string1=&make_string($fs_array,$sent);
							&modify_field($nodes[$j],4,$string1);
						}
						$fs=&get_field($nodes[$j],4);
						$fs_array = &read_FS($fs,$sent);
						&update_attr_val("lex",\@lex, $fs_array,$sent);
						my $string=&make_string($fs_array,$sent);
						&modify_field($nodes[$j],4,$string);
						$j++;
					}
				}

			}
			if($i!=1 and $i!=2) {
				$pword3 = &get_field($nodes[$i-1],4);
				$fs_array3 = &read_FS($pword1);
				my @lex3 = &get_values("lex", $fs_array3);
				my @cat3 = &get_values("cat", $fs_array1);
				my @drel = &get_values("drel", $fs_array3);
				my @name3 = &get_values("name", $fs_array3);
				foreach $lex1(@lex1) {
					$pword1 = $lex1;
					$vib1 = $vib1[0];
				}
				if(($cat3[0] eq "adj")&&($cat2[0] eq "punc")&&($cat1[0] eq "adj")&&($cat[0] eq "n")&&($pword1 == $lex1[0])){
					my @num;
					$num[0]="pl";
					$fs=&get_field($nodes[$i],4);
					$fs_array = &read_FS($fs,$sent);
					&update_attr_val("num",\@num, $fs_array,$sent);
					my $string=&make_string($fs_array,$sent);
					&modify_field($nodes[$i],4,$string);
					#$i++;
					#this was changed because it no adj was passing from this - chris-31-10-2011
					$i+1;
				}
			}


			if($i!=0) {
				$pword1 = &get_field($nodes[$i-1],4);
				$fs_array1 = &read_FS($pword1);
				@lex1 = &get_values("lex", $fs_array1);
				@cat1 = &get_values("cat", $fs_array1);
				@name1 = &get_values("name", $fs_array1);
				my @vib = &get_values("vib", $fs_array1);

				foreach $lex1(@lex1) {
					$lex1=~s/_.*$//g;
					$pword1 = $lex1;
				}
				$pword2="";
				$key1=$pword1." ".$cword;

				if($root_hash{$key1} ne "") {

					my @arr=split(" ",$root_hash{$key1});
					$p=$root_hash{$key1};
					$j=$i-1;

					foreach (@arr) {
						&modify_field($nodes[$j],2,$_);
						$fs=&get_field($nodes[$j],4);
						$fs_array = &read_FS($fs,$sent);
						$fs2=&get_field($nodes[$j-1],4);
						$fs_array2 = &read_FS($fs2,$sent);
						$lex[0]=$_;
						if($lex[0]!~/^-/){
							$lex[0]="^@".$lex[0];
						}
						if($lex[0]=~/:/){
							($templex,$cas)=split(/:/,$lex[0]);
							$cas=~s/-/-^@/g;
							$cas=~s/_/_^@/g;
							$newvib1[0]="^-@".$cas;
							$lex[0]=$templex;
							&update_attr_val("vib",\@newvib1, $fs_array,$sent);
							my $string1=&make_string($fs_array,$sent);
							&modify_field($nodes[$j],4,$string1);
						}
						&modify_field($nodes[$j],2,$lex[0]);
						&update_attr_val("lex",\@lex, $fs_array,$sent);
						my $string=&make_string($fs_array,$sent);
						my $string2=&make_string($fs_array2,$sent);
						&modify_field($nodes[$j],4,$string);
						&modify_field($nodes[$j-1],4,$string2);
						$j++;
						$vib1[0]="";
					}
				}
			}
			&modify_field($node,2,$root);
			&update_attr_val("lex", \@lex, $fs_array,$sent);
			my $string=&make_string($fs_array,$sent);
			&modify_field($node,4,$string);
		}
	}
}
&mul_word();
if($output eq "") {
	&print_tree();
}
else {
	&print_tree_file($output);
}
