/**************************************************/
/******DEPARTMENT OF SANSKRIT STUDIES *************/
/******UNIVERSITY OF HYDERABAD ********************/
/**********HINDI-URDU TRANSLITERATION PROGRAM******/
/*********DEVELOPERS : Amba Kulkarni          **/   
/***                   Rahmat Yousufzai        ****/
/**************************************************/
word [ \t\n]+
%%
अंप       { printf("امپ"); }
अंफ      { printf("امپھ"); }
अंब      { printf("امب"); }
अंभ      { printf("امبھ"); }
अंम      { printf("امم"); }
अं/[ \t\n]  { printf("ام"); }
अं  { printf("ان"); }

आंप      { printf("آںپ"); }
आंफ     { printf("آںپھ"); }
आंब     { printf("آمب"); }
आंभ     { printf("آمبھ"); }
आंम      { printf("آمم"); }
आं/[ \t\n]     { printf("%cام",yytext[0]); }
[ \t\n]आं   { printf("%cآں",yytext[0]); }


[ \t\n]इंप  { printf("%cاِمپ",yytext[0]); }
[ \t\n]इंफ  { printf("%cاِمپھ",yytext[0]); }
[ \t\n]इंब  { printf("%cاِمب",yytext[0]); }
[ \t\n]इंभ  { printf("%cامبھ",yytext[0]); }
[ \t\n]इंम  { printf("%cاِمم",yytext[0]); }
[ \t\n]इं  { printf("%cاِن",yytext[0]); }
इंप  { printf("ئمپ"); }
इंफ  { printf("ئمپھ"); }
इंब  { printf("ئمب"); }
इंभ  { printf("ئمبھ"); }
इंम  { printf("ئمم"); }
इं/[ \t\n] { printf("ئم"); }
इं   { printf("ئن"); }


[ \t\n]ईंप  { printf("%cایمپ",yytext[0]); }
[ \t\n]ईंफ  { printf("%cایمپھ",yytext[0]); }
[ \t\n]ईंब  { printf("%cایمب",yytext[0]); }
[ \t\n]ईंभ  { printf("%cایمبھ",yytext[0]); }
[ \t\n]ईंम  { printf("%cایمم",yytext[0]); }
[ \t\n]ईं  { printf("%cاین",yytext[0]); }
ईंप  { printf("ئیمپ"); }
ईंफ  { printf("ئیمپھ"); }
ईंब  { printf("ئیمب"); }
ईंभ  { printf("ئیمبھ"); }
ईंम  { printf("ئیمم"); }
ईं/[ \t\n]  { printf("ئیم"); }
ईं  { printf("ئین"); }


[ \t\n]उंप  { printf("%cاُمپ",yytext[0]); }
[ \t\n]उंफ  { printf("%cاُمپھ",yytext[0]); }
[ \t\n]उंब  { printf("%cاُمب",yytext[0]); }
[ \t\n]उंभ  { printf("%cاُمبھ",yytext[0]); }
[ \t\n]उंम  { printf("%cاُمم",yytext[0]); }
[ \t\n]उं  { printf("%cاُن",yytext[0]); }
उंप  { printf("ؤمپ"); }
उंफ  { printf("ؤمپھ"); }
उंब  { printf("ؤمب"); }
उंभ  { printf("ؤمبھ"); }
उंम  { printf("ؤمم"); }
उं/[ \t\n]  { printf("ؤم"); }
उं  { printf("ؤن"); }


[ \t\n]ऊंप  { printf("%cاُومپ",yytext[0]); }
[ \t\n]ऊंफ  { printf("%cاُومپھ",yytext[0]); }
[ \t\n]ऊंब  { printf("%cاُومب",yytext[0]); }
[ \t\n]ऊंभ  { printf("%cاُومبھ",yytext[0]); }
[ \t\n]ऊंम  { printf("%cاُومم",yytext[0]); }
[ \t\n]ऊं { printf("%cاُون",yytext[0]); }
ऊंप  { printf("ؤمپ"); }
ऊंफ  { printf("ؤمپھ"); }
ऊंब  { printf("ؤمب"); }
ऊंभ  { printf("ؤمبھ"); }
ऊंम  { printf("ؤمم"); }
ऊं/[ \t\n]  { printf("ؤم"); }
ऊं { printf("ؤن"); }


[ \t\n]एंप  { printf("%cاےمپ",yytext[0]); }
[ \t\n]एंफ  { printf("%cاےمپھ",yytext[0]); }
[ \t\n]एंब  { printf("%cاےمب",yytext[0]); }
[ \t\n]एंभ  { printf("%cاےمبھ",yytext[0]); }
[ \t\n]एंम  { printf("%cاےمم",yytext[0]); }
[ \t\n]एं { printf("%cاےن",yytext[0]); }
एंप  { printf("ۓمپ"); }
एंफ  { printf("ۓمپھ"); }
एंब  { printf("ۓمب"); }
एंभ  { printf("ۓمبھ"); }
एंम  { printf("ۓمم"); }
एं/[ \t\n]  { printf("ۓم"); }
एं  { printf("ۓن"); }


[ \t\n]ऐंप  { printf("%cاَےمپ",yytext[0]); }
[ \t\n]ऐंफ  { printf("%cاَےمپھ",yytext[0]); }
[ \t\n]ऐंब  { printf("%cاَےمب",yytext[0]); }
[ \t\n]ऐंभ  { printf("%cاَےمبھ",yytext[0]); }
[ \t\n]ऐंम  { printf("%cاَےمم",yytext[0]); }
[ \t\n]ऐं { printf("%cاَےن",yytext[0]); }
ऐंप  { printf("ۓمپ"); }
ऐंफ  { printf("ۓمپھ"); }
ऐंब  { printf("ۓمب"); }
ऐंभ  { printf("ۓمبھ"); }
ऐंम  { printf("ۓمم"); }
ऐं/[ \t\n]  { printf("ۓم"); }
ऐं  { printf("ۓن"); }

[ \t\n]ओंप  { printf("%cاومپ",yytext[0]); }
[ \t\n]ओंफ  { printf("%cاومپھ",yytext[0]); }
[ \t\n]ओंब  { printf("%cاومب",yytext[0]); }
[ \t\n]ओंभ  { printf("%cاومبھ",yytext[0]); }
[ \t\n]ओंम  { printf("%cاومم",yytext[0]); }
[ \t\n]ओं { printf("%cاون",yytext[0]); }
ओंप  { printf("ؤمپ"); }
ओंफ  { printf("ؤمپھ"); }
ओंब  { printf("ؤمب"); }
ओंभ  { printf("ؤمبھ"); }
ओंम  { printf("ؤمم"); }
ओं/[ \t\n]  { printf("ؤم"); }
ओं { printf("ؤن"); }


[ \t\n]औंप  { printf("%cاَومپ",yytext[0]); }
[ \t\n]औंफ  { printf("%cاَومپھ",yytext[0]); }
[ \t\n]औंब  { printf("%cاَومب",yytext[0]); }
[ \t\n]औंभ  { printf("%cاَومبھ",yytext[0]); }
[ \t\n]औंम  { printf("%cاَومم",yytext[0]); }
[ \t\n]औं  { printf("%cاَون",yytext[0]); }
औंप  { printf("ؤمپ"); }
औंफ  { printf("ؤمپھ"); }
औंब  { printf("ؤمب"); }
औंभ  { printf("ؤمبھ"); }
औंम  { printf("ؤمم"); }
औं/[ \t\n]  { printf("ؤم"); }
औं  { printf("ؤن"); }


कं/[पफबभम]  { printf("کم"); }
कं/[ \t\n]  { printf("کم"); }
कं  { printf("کن"); }

खं/[पफबभम]   { printf("کم"); }
खं/[ \t\n]  { printf("کم"); }
खं  { printf("کن"); }

गं/[पफबभम] { printf("گم"); }
गं/[ \t\n]  { printf("گم"); }
गं  { printf("گن"); }

घं/[पफबभम] { printf("گھم"); }
घं/[ \t\n]  { printf("گھم"); }
घं  { printf("گھن"); }

चं/[पफबभम] { printf("چم"); }
चं/[ \t\n]  { printf("چم"); }
चं  { printf("چن"); }

छं/[पफबभम] { printf("چھم"); }
छं/[ \t\n]  { printf("چھم"); }
छं  { printf("چھن"); }
 
जं/[पफबभम] { printf("جم"); }
जं/[ \t\n]  { printf("جم"); }
जं  { printf("جن"); }

झं/[पफबभम] { printf("جھم"); }
झं/[ \t\n]  { printf("جھم"); }
झं  { printf("جھن"); }

टं/[पफबभम] { printf("ٹم"); }
टं/[ \t\n]  { printf("ٹم"); }
टं  { printf("ٹن"); }

ठं/[पफबभम] { printf("ٹھم"); }
ठं/[ \t\n]  { printf("ٹھم"); }
ठं  { printf("ٹھن"); }

डं/[पफबभम] { printf("ڈم"); }
डं/[ \t\n]  { printf("ڈم"); }
डं { printf("ڈن"); }

ड़ं/[पफबभम] { printf("ڑم"); }
ड़ं/[ \t\n]  { printf("ڑم"); }
ड़ं { printf("ڑن"); }

ढं/[पफबभम] { printf("ڈھم"); }
ढं/[ \t\n]  { printf("ڈھم"); }
ढं { printf("ڈھن"); }

ढ़ं/[पफबभम] { printf("ڑھم"); }
ढ़ं/[ \t\n]  { printf("ڑھم"); }
ढ़ं { printf("ڑھن"); }

णं/[पफबभम] { printf("نم"); }
णं/[ \t\n]  { printf("نم"); }
णं { printf("نن"); }

तं/[पफबभम] { printf("تم"); }
तं/[ \t\n]  { printf("تم"); }
तं { printf("تن"); }

थं/[पफबभम] { printf("تھم"); }
थं/[ \t\n]  { printf("تھم"); }
थं { printf("تھن"); }

दं/[पफबभम] { printf("دم"); }
दं/[ \t\n]  { printf("دم"); }
दं { printf("دن"); }

धं/[पफबभम] { printf("دم"); }
धं/[ \t\n]  { printf("دم"); }
धं { printf("دن"); }

नं/[पफबभम] { printf("نم"); }
नं/[ \t\n]  { printf("نم"); }
नं { printf("نن"); }

पं/[पफबभम] { printf("پم"); }
पं/[ \t\n]  { printf("پم"); }
पं { printf("پن"); }

फं/[पफबभम] { printf("پھم"); }
फं/[ \t\n]  { printf("پھم"); }
फं { printf("پھن"); }

बं/[पफबभम] { printf("بم"); }
बं/[ \t\n]  { printf("بم"); }
बं { printf("بن"); }

भं/[पफबभम] { printf("بھم"); }
भं/[ \t\n]  { printf("بھم"); }
भं { printf("بھن"); }

मं/[पफबभम] { printf("مم"); }
मं/[ \t\n]  { printf("مم"); }
मं { printf("من"); }

यं/[पफबभम] { printf("یم"); }
यं/[ \t\n]  { printf("یم"); }
यं { printf("ین"); }

रं/[पफबभम] { printf("رم"); }
रं/[ \t\n]  { printf("رم"); }
रं { printf("رن"); }

लं/[पफबभम] { printf("لم"); }
लं/[ \t\n]  { printf("لم"); }
लं { printf("لن"); }

वं/[पफबभम] { printf("وم"); }
वं/[ \t\n]  { printf("وم"); }
वं { printf("ون"); }

शं/[पफबभम] { printf("شم"); }
शं/[ \t\n]  { printf("شم"); }
शं { printf("شن"); }

षं/[पफबभम] { printf("شم"); }
षं/[ \t\n]  { printf("شم"); }
षं { printf("شن"); }

सं/[पफबभम] { printf("سم"); }
सं/[ \t\n]  { printf("سم"); }
सं { printf("سن"); }

हं/[पफबभम] { printf("ہم"); }
हं/[ \t\n]  { printf("ہم"); }
हं { printf("ہن"); }

क्षं/[पफबभम] { printf("کْشم"); }
क्षं/[ \t\n]  { printf("کْشم"); }
क्षं { printf("کْشن"); }

त्रं/[पफबभम] { printf("تْرم"); }
त्रं/[ \t\n]  { printf("تْرم"); }
त्रं { printf("تْرن"); }

ज्ञं/[पफबभम] { printf("گْیَم"); }
ज्ञं/[ \t\n]  { printf("گْیَم"); }
ज्ञं { printf("گْیَن"); }

[ \t\n]इः  { printf("%cاِہ",yytext[0]); }
इः { printf("ئہ"); }

[ \t\n]ईः  { printf("%cایہ",yytext[0]); }
ईः { printf("ئیہ"); }

[ \t\n]उः  { printf("%cاُہ",yytext[0]); }
उः { printf("ؤہ"); }

[ \t\n]ऊः  { printf("%cاُوہ",yytext[0]); }
ऊः { printf("ؤہ"); }

[ \t\n]एः  { printf("%cاےہ",yytext[0]); }
एः { printf("ۓہ"); }

[ \t\n]ऐः  { printf("%cاَےہ",yytext[0]); }
ऐः { printf("ۓہ"); }

[ \t\n]ओः  { printf("%cاوہ",yytext[0]); }
ओः { printf("ؤہ"); }

[ \t\n]औः  { printf("%cاَوہ",yytext[0]); }
औः { printf("ؤہ"); }

अँ/[ \t\n]  { printf("اں"); }
अँ  { printf("ان"); }

आँ/[ \t\n]  { printf("آں"); }
आँ  { printf("آن"); }

[ \t\n]इँ/[पफबभम]  { printf("%cاِم",yytext[0]); }
[ \t\n]इँ  { printf("%cاِن",yytext[0]); }
इँ/[पफबभम]  { printf("ئم"); }
इँ/[ \t\n]  { printf("ئں"); }
इँ { printf("ئن"); }

[ \t\n]ईँ/[पफबभम]  { printf("%cایم",yytext[0]); }
[ \t\n]ईँ  { printf("%cاین",yytext[0]); }
ईँ/[पफबभम]  { printf("ئیم"); }
ईँ/[ \t\n]  { printf("ئیں"); }
ईँ  { printf("ئین"); }

[ \t\n]उँ/[पफबभम]  { printf("%cاُم",yytext[0]); }
[ \t\n]उँ  { printf("%cاُن",yytext[0]); }
उँ/[पफबभम]  { printf("ؤم"); }
उँ/[ \t\n]  { printf("ؤں"); }
उँ  { printf("ؤن"); }

[ \t\n]ऊँ/[पफबभम]  { printf("%cاُوم",yytext[0]); }
[ \t\n]ऊँ  { printf("%cاُون",yytext[0]); }
ऊँ/[पफबभम]  { printf("ؤم"); }
ऊँ/[ \t\n]  { printf("ؤں"); }
ऊँ  { printf("ؤن"); }

[ \t\n]एँ/[पफबभम]  { printf("%cاےم",yytext[0]); }
[ \t\n]एँ  { printf("%cاےن",yytext[0]); }
एँ/[पफबभम]  { printf("ۓم"); }
एँ/[ \t\n]  { printf("ۓں"); }
एँ  { printf("ۓن"); }

क़ं/[पफबभम]  { printf("قم"); }
क़ं/[ \t\n]  { printf("قم"); }
क़ं { printf("قن"); }

ख़ं/[पफबभम]  { printf("خم"); }
ख़ं/[ \t\n]  { printf("خم"); }
ख़ं { printf("خن"); }

ग़ं/[पफबभम]  { printf("غم"); }
ग़ं/[ \t\n]  { printf("غم"); }
ग़ं { printf("غن"); }

ज़ं/[पफबभम]  { printf("زم"); }
ज़ं/[ \t\n]  { printf("زم"); }
ज़ं { printf("زن"); }

त़ं/[पफबभम]  { printf("طم"); }
त़ं/[ \t\n]  { printf("طم"); }
त़ं { printf("طن"); }

फ़ं/[पफबभम]  { printf("فم"); }
फ़ं/[ \t\n]  { printf("فم"); }
फ़ं { printf("فن"); }

स़ं/[पफबभम]  { printf("صم"); }
स़ं/[ \t\n]  { printf("صم"); }
स़ं { printf("صن"); }

ह़ं/[पफबभम]  { printf("حم"); }
ह़ं/[ \t\n]  { printf("حم"); }
ह़ं { printf("حن"); }






अ       { printf("ا"); }
आ      { printf("ﺁ");}


{word}/इ { printf("ﺍِ");}
इ      { printf("ئ");}
{word}/ई      { printf("ای");}
ई      { printf("ئی");}
{word}/उ      { printf("اُ"); }
उ      { printf("ؤ"); }

{word}/ऊ      { printf("اُو");}
ऊ      { printf("ﺅ");}

{word}/ए      { printf("اے");}
ए      { printf("ۓ");}

{word}/ऐ      { printf("اَے");}
ऐ      { printf("ۓ");}
{word}/ओ       { printf("ؤ");}
ओ       { printf("ﺍﻭ");}
{word}/औ       { printf("اَو");}
औ	{ printf("ؤ");}
 ं	{ printf("ن"); }
 ं$	{ printf("ں"); }
 ः	{ printf("ہ"); }
 ँ	{ printf("ن"); }
 ँ$	{ printf("ں"); }


क़	{ printf("ق"); }
ख़	{ printf("خ"); }
ग़	{ printf("غ"); }
ज़	{ printf("ز"); }
ड़	{ printf("ڑ"); }
ढ़	{ printf("ڑھ"); }
फ़	{ printf("ف"); }
त़	{ printf("ط"); }
स़	{ printf("ص"); }
ह़	{ printf("ح"); }

क	{ printf("ک"); }
ख	{ printf("کھ"); }
ग	{ printf("گ"); }
घ	{ printf("گھ"); }
ङ	{ printf("ن"); }
च	{ printf("چ"); }
छ	{ printf("چھ"); }
ज	{ printf("ج"); }
झ	{ printf("جھ"); }
ञ	{ printf("ن"); }
ट	{ printf("ٹ"); }
ठ	{ printf("ٹھ"); }
ड	{ printf("ڈ"); }
ढ	{ printf("ڈھ"); }
ण	{ printf("ن"); }
त	{ printf("ت"); }
थ	{ printf("تھ"); }
द	{ printf("د"); }
ध	{ printf("دھ"); }
न	{ printf("ن"); }
प	{ printf("پ"); }
फ	{ printf("پھ"); }
ब	{ printf("ب"); }
भ	{ printf("بھ"); }
म	{ printf("م"); }


य	{ printf("ی"); }
य[ \t\n]+  { printf("ۓ"); }
 ्य      { printf("یہ"); }

र	{ printf("ر"); }
ल	{ printf("ل"); }
व       {  printf("ﻭ"); }

श	{ printf("ش"); }
ष	{ printf("ش"); }
स	{ printf("س"); }
ह	{ printf("ہ"); }

क्ष              { printf("کْش"); }
त्र              { printf("تْر"); }
ज्ञ[ \t\n]+   { printf("گیہ"); }
ज्ञ              { printf("گْی"); }

ा	{ printf("ا"); }

 ि$	{ printf("ی"); }
 ि	{ printf("ِ"); }
ी	{ printf("ی"); }
ु	{ printf("ُ"); }
ू	{ printf("و"); }
े	{ printf("ے"); }
ै	{ printf("ے"); }
ो	{ printf("و"); }
ौ	{ printf("ؤ"); }
ॉ             { printf(""); }

क़्क़	{ printf("قّ"); }
क़्क़	{ printf("قّ");}
ख़्ख़	{ printf("خّ"); }
ग़्ग़	{ printf("غّ"); }
ज़्ज़	{ printf("زّ"); }
ड़्ड़	{ printf("ڑّ"); }
ढ़्ढ़	{ printf("ڑھّ"); }
फ़्फ़	{ printf("فّ"); }
क्क	{ printf("کّ"); }
ख्ख	{ printf("کھّ"); }
ग्ग	{ printf("گّ"); }
घ्घ	{ printf("گھّ"); }
ङ्ङ	{ printf("نّ"); }
च्च	{ printf("چّ"); }
छ्छ	{ printf("چھّ"); }
ज्ज	{ printf("جّ"); }
झ्झ	{ printf("جھّ"); }
ञ्ञ	{ printf("نّ"); }
ट्ट	{ printf("ٹّ"); }
ठ्ठ	{ printf("ٹھّ"); }
ड्ड	{ printf("ڈّ"); }
ढ्ढ	{ printf("ڈھّ"); }
ण्ण	{ printf("نّ"); }
त्त	{ printf("تّ"); }
थ्थ	{ printf("تھّ"); }
द्द	{ printf("دّ"); }
ध्ध	{ printf("دھّ"); }
न्न	{ printf("نّ"); }
प्प	{ printf("پّ"); }
फ्फ	{ printf("پھّ"); }
ब्ब	{ printf("بّ"); }
भ्भ	{ printf("بھّ"); }
म्म	{ printf("مّ"); }
य्य	{ printf("یّ"); }
र्र	{ printf("رّ"); }
ल्ल	{ printf("لّ"); }
व्व	{ printf("وّ"); }
श्श	{ printf("شّ"); }
ष्ष	{ printf("شّ"); }
स्स	{ printf("سّ"); }
ह्ह	{ printf("ہّ"); }

 ्     { printf("");}

%%


int main(void)
{
    /* Call the lexer, then quit. */
    yylex();
    return 0;
}
