import os, sys, codecs, re, argparse
from indictrans import Transliterator

parser = argparse.ArgumentParser()
parser.add_argument('-s', metavar='source', dest="source", choices=["kan","hin", "tel"], default="kan", help="source script [tamil|hindi]", required=True)
parser.add_argument('-t', metavar='target', dest="target", choices=["hin", "kan", "tel"], default="hin", help="source script [hindi|tamil]", required=True)
parser.add_argument('-i', metavar='inputFile', dest="inputFile", help="<input-file>", required=True)
args = parser.parse_args()

src = args.source
tgt = args.target
inputFile = args.inputFile
#print src, tgt, inputFile

if (inputFile is None):
    print "please enter input file"
    exit()

if (src is None) or (tgt is None):
    print "please enter source or target value!!"
    exit()


if not os.path.exists(inputFile):
    print "please enter input file"
    exit()


trn = Transliterator(source=src, target=tgt)

f = codecs.open(inputFile, "rb", "utf-8")
lines = f.readlines()
f.close()

def transliterateString(mystr):
    inarray = filter(None, re.split(r'(\d+)', mystr))
    outarray = []
    for item in inarray:
	if item.isdigit():
	    outarray.append(item)
	else:
	    transliteration_output = trn.transform(item)
	    outarray.append(transliteration_output)
    return "".join(outarray)
	
def transliterate(lines):
    transliteratedlines = ""
    #for line in lines:
    finalarray = []
    for ii in xrange(len(lines)):
	line = lines[ii]
        line = line.rstrip()
        if line:
	    #line = " ".join(line.split())
	    linearray = line.split('\t')
	    ##print len(linearray)
	    if len(linearray) == 4:
		
		
	        mainfeatures = linearray[3][1:-1].split(" ")
  	        af = mainfeatures[1].split("=")[1][1:-1]
		linearray[3] = linearray[3].strip()
		if linearray[1] != "((" and linearray[1] != "))":
		    if linearray[1].startswith('@'):
			transliterated_token = "@" + transliterateString(linearray[1][1:])
			linearray[1] = transliterated_token
	        if linearray[3]:		    
		    if af.startswith('@'):
		        afarray = af.split(',')
		        root = afarray[0]
		        roottobetransliterated = root[1:]
		        transliterated_root = "@" + transliterateString(roottobetransliterated)
		        #print transliterated_root
		        afarray[0] = transliterated_root
		        af = ",".join(afarray)
		        mainfeatures[1] = 'af=\''+af+'\''

		    for i in xrange(len(mainfeatures)):
			ftrelement = mainfeatures[i]
			head = ""
			transliteratedhead = ""
			if ftrelement.startswith('head='):
			    if ftrelement.startswith('head=\'@') or ftrelement.startswith('head=\"@'):
			        head = ftrelement.split("head=")[1][1:-1][1:]
			        transliteratedhead = "@" + transliterateString(head)
			    else:
			        head = ftrelement.split("head=")[1][1:-1]
			        transliteratedhead = head

			        mainfeatures[i] = 'head=\''+transliteratedhead+'\''

			if ftrelement.startswith('name='):
			    if ftrelement.startswith('name=\'@') or ftrelement.startswith('name=\"@'):
			        head = ftrelement.split("name=")[1][1:-1][1:]
			        transliteratedhead = "@" + transliterateString(head)
			    else:
			        head = ftrelement.split("name=")[1][1:-1]
			        transliteratedhead = head

			        mainfeatures[i] = 'name=\''+transliteratedhead+'\''

			if ftrelement.startswith('vib='):
			    if ftrelement.startswith('vib=\'@') or ftrelement.startswith('vib=\"@'):
			        head = ftrelement.split("vib=")[1][1:-1][1:]
			        transliteratedhead = "@" + transliterateString(head)
			    else:
			        head = ftrelement.split("vib=")[1][1:-1]
			        transliteratedhead = head

			        mainfeatures[i] = 'vib=\''+transliteratedhead+'\''

			
		    linearray[3] = '<'+" ".join(mainfeatures)+'>'
		    line = '\t'.join(linearray)
		    lines[ii] = line

	        
				
	    finalarray.append(lines[ii].rstrip())
	    transliteratedlines += lines[ii] + "\n"
	    #print line
    #return transliteratedlines.encode('utf-8')
    #print finalarray
    return '\n'.join(finalarray).encode('utf-8')

print transliterate(lines)
